#version 450 core

in vec2 texCoords;

struct Material {
	sampler2D texture_diffuse1; // actually colormap
	sampler2D texture_specular1; // actually depthmap
};

uniform Material material;

// takes the nearest depth of a 2x2 neighborhood
void main() {
	vec2 uv = texCoords;
	uv.y = uv.y * -1 + 1;
	float nearestDepth = 9999999999999.0;
	float farthestDepth = 0.0;

	vec4 depths = textureGather(material.texture_specular1, uv, 0);
	for (int i = 0; i < 4; i++) {
		float d = depths[i];
		nearestDepth = min(nearestDepth, d);
		farthestDepth = max(farthestDepth, d);
	}
	vec2 position = mod(gl_FragCoord.xy, 2);
	int index = int(position.x + position.y);
	gl_FragDepth = index == 1 ? nearestDepth : farthestDepth;
	//gl_FragDepth = nearestDepth;
}
