#version 450 core
layout (location = 0) in vec3 aPos;
layout (location = 1) in vec3 aNormal;
layout (location = 2) in vec2 aTexCoords;

uniform mat4 model;
uniform mat4 view;
uniform mat4 projection;
uniform mat4 lightSpaceMatrix;

//out VS_FS_INTERFACE {
out vec3 worldPos;
out vec4 lightSpacePos;
out vec2 texCoords;
out vec3 normal;
//} vertex;

void main() {
	gl_Position = projection * view * model * vec4(aPos.x , aPos.y , aPos.z , 1.0);
	texCoords = aTexCoords;

	// fragment position to world- and lightspace
    worldPos = vec3(model * vec4(aPos , 1.0));
	lightSpacePos = lightSpaceMatrix * vec4(worldPos, 1.0); 

	// normal direction to worldspace
	mat3 invTransModel = mat3(transpose(inverse(model)));
	normal = invTransModel * aNormal;
};